<?php

class XcruderModule extends CWebModule
{

/**
 * Members from Module config
 */
	public $c_models = array('application.models.*');
	public $models = null;

	public function init()
	{
	
		if (!isset(Yii::app()->params['pageSize']))
			Yii::app()->params['pageSize'] = 8;

		// import the module-level models and components
		$this->setImport(array(
			'xcruder.models.*',
			'xcruder.components.*',
			'xcruder.controllers.*',
			//'xcruder.extensions.rowpicker.*'
		));

		$cs = Yii::app()->getClientScript();
		
		$systemJsPath =
			Yii::app()->getAssetManager()->publish( Yii::getPathOfAlias( 'system.web.js' ), 
							false, -1, false );
		$moduleAssetsPath =
			Yii::app()->getAssetManager()->publish( Yii::getPathOfAlias( $this->getId() . '.assets'), 
							false, -1, @Yii::app()->params['dev'] );

		//Linking asset files
		$cs->registerCssFile( $systemJsPath . '/source/jui/css/base/jquery-ui.css');
		$cs->registerCssFile( $moduleAssetsPath . '/css/xcruder.css');

		$cs->registerScriptFile( $systemJsPath . '/source/jui/js/jquery-ui.min.js');

if (false) {		
		$cs->registerScriptFile( $systemJsPath . '/ext/yii_ext.js');
		$cs->registerScriptFile( $systemJsPath . '/ext/jquery/json/jquery.json.js');
		$cs->registerScriptFile( $systemJsPath . '/ext/jquery/form/jquery.form.js');
		$cs->registerScriptFile( $systemJsPath . '/ext/jquery/nlac-xmask/jquery.xmask.js');
} else {
		$cs->registerScriptFile( $moduleAssetsPath . '/js/yii_ext.js');
		$cs->registerScriptFile( $moduleAssetsPath . '/js/jquery/json/jquery.json.js');
		$cs->registerScriptFile( $moduleAssetsPath . '/js/jquery/form/jquery.form.js');
		$cs->registerScriptFile( $moduleAssetsPath . '/js/jquery/nlac-xmask/jquery.xmask.js');
}
		$cs->registerScriptFile( $moduleAssetsPath . '/js/xcruder.js');
		$cs->registerScriptFile( $moduleAssetsPath . '/js/xcruder.gridview.js');

		$this->getModels();
	}

	public function getModels()
	{
			if ($this->models)
					return $this->models;

			$this->models = array();

			if (!empty($this->c_models))
			{
					if (!is_array($this->c_models))
						$this->c_models = array($this->c_models);

					foreach($this->c_models as $model)
					{
							Yii::import($model);

							if (substr($model, -1)=='*')
							{
									$files=CFileHelper::findFiles(Yii::getPathOfAlias($model));
									if ($files)
									{
											foreach($files as $file)
											{
												 $class_name=str_replace('.php','',substr(strrchr($file,DIRECTORY_SEPARATOR), 1));
												 $this->models[] = $class_name;
											}
									}
							}
							else
							{
									$class_name=substr(strrchr($model, "."), 1);
									$this->models[] = $class_name;
							}
					}
			}

			return array_unique($this->models);
	}


}
