/**
 * Masker plugin by nlac
 * @nlac 2011
 * nlacsoft@gmail.com
 * nlacsoft.net
 **/
(function($){

$.widget("ui.xmask", {

	_timer : undefined,
	
	//element position+dimensions
	_size : {},
	_offset : {},
	
	//message dimensions
	_size_mess : {},
	
	//saved overflow css rule for the document
	_overflow : undefined,
	
	//is the maskable element the full document?
	_isDoc : false,
	
	//$(document) or this.element
	_dimEl : undefined,

	//start timestamp
	_start : 0,

	options : {
		message : "",
		className : "",
		timeOut : 0
	},
	
	destroy : function() {
		//console.log("destroy called", this.options);
		if (this._timer) {clearTimeout(this._timer);this._timer = undefined;}
		
		var el = this.element;
		
		el.find("> .xmask").remove();
		el.find("> .xmask-mess").remove();
		
		if (this._isDoc)
			el.css({
				overflow : this._overflow
			});
		
		$.Widget.prototype.destroy.call( this );
	},

	hide : function() {

		var el = this.element;
		
		if (this._timer) {clearTimeout(this._timer);this._timer = undefined;}

		el.find("> .xmask").hide();
		el.find("> .xmask-mess").hide();

		if (this._isDoc)
			el.css({
				overflow : this._overflow
			});
	},

	_setOptions: function( opts ) {
		if (this._timer) {clearTimeout(this._timer);this._timer = undefined;}
		for(var key in opts) {
			
			var val = opts[key];//, oldval = this.options[key];
			
			this["_set" + key](val);

			this.options[key] = val;
		}

		this._pos();
	},
	
	_settimeOut : function(_timeOut) {
		this._start = (new Date()).getTime();
	},
	
	_setmessage : function(_mess) {
		var messcont = this.element.find("> .xmask-mess");
		if (!_mess && _mess !== "" && _mess !== 0)
			messcont.remove();
		else {
			if (!messcont.length)
				messcont = $("<span class=\"xmask-mess\"><span></span></span>").css({
					position : "absolute"
				}).appendTo(this.element);

			messcont.show();
	
			var inner = messcont[0].firstChild;
			if (_mess.constructor == String)
				inner.innerHTML = _mess;
			else {
				$(inner).empty().append(_mess.css({
					display:"block",
					visiblity:"visible"
				}));
			}
		}
	},

	_setclassName : function(_className) {
		if (!_className)
			_className = "";
		this.element.find("> .xmask").removeAttr("className").addClass("xmask ui-widget-overlay " + _className);
		this.element.find("> .xmask-mess").removeAttr("className").addClass("xmask-mess " + _className);
	},

	_pos : function() {

		var el = this.element, opts = this.options, m = el.find("> .xmask");

		if (!el.length || !m.length || !el[0].parentNode || !m[0].parentNode) {
			return;
		}

		if (opts.timeOut && parseInt(opts.timeOut)>0)
			if ((new Date()).getTime() > this._start + parseInt(opts.timeOut)) {
				this.hide();
				return;
			}

		var dimEl = this._dimEl, mc = el.find("> .xmask-mess");
			
		//if mask is visible -> MAY needed to correct its position
		if (m.is(":visible")) {

			//element's position
			var offset = el.offset();
			var size = this._isDoc ? {
				w : dimEl.width(),
				h : dimEl.height()
			} : {
				w : el.outerWidth(),
				h : el.outerHeight()				
			};
			
			var bPosMessage = false;
			
			//correcting mask
			if (this._size.w!=size.w || this._size.h!=size.h ||
			this._offset.top != offset.top || this._offset.left != offset.left) {
				if (this._isDoc) {
					
					m.position({
			  		my: "left top",
			  		at: "left top",
			  		of: dimEl
			  	}).width(size.w).height(size.h);

				} else {

					m.width(size.w).height(size.h).position({
			  		my: "left top",
			  		at: "left top",
			  		of: dimEl
			  	});

			  }
			  
			  bPosMessage = true;
			}

			this._size = size;
			this._offset = offset;



			//correcting message
			if (mc.length && mc[0].parentNode) {
				var size_mess = {w:mc.outerWidth(),h:mc.outerHeight()};
	
				if (bPosMessage || this._size_mess.w != size_mess.w || this._size_mess.h != size_mess.h) {
					mc.position({
			  		my: "center center",
			  		at: "center center",
			  		of: dimEl
			  	});
				}

				this._size_mess = size_mess;
			}

		}//m:visible


		var _this = this;
		this._timer = setTimeout(function(){
			_this._pos();
		}, 500);

	},

	//Called once
	_create : function() {
		//console.log("create called");
		
		if (this.element[0] == document)
			this.element = $(document.body);

		var opts = this.options, el = this.element;
		
		this._isDoc = (el[0] == document.body);
		this._dimEl = this._isDoc ? $(document) : el;

	},
	
	//Entry point
	_init : function() {
		//console.log("init called", this.options);
		
		if (this._timer) {clearTimeout(this._timer);this._timer = undefined;}
		
		var el = this.element, mask = el.find("> .xmask");

		if (this._isDoc) {
			this._overflow = el.css("overflow");
			el.css({
				overflow : "hidden"
			});
		}

		if (!mask.length)
			mask = $("<div/>").css({
				position:"absolute",
				margin : 0,
				padding : 0
			}).width(1).height(1).addClass("ui-widget-overlay xmask").appendTo(el);
		
		mask.show();
		
		this._size = {};
		this._size_mess = {};
		
		this._setclassName(this.options.className);
		this._setmessage(this.options.message);
		
		this._start = (new Date()).getTime();
		this._pos();
	}
	
});

})(jQuery);
